/* Copyright 2004, 2005, 2007 Columbia University */
/* This file is part of THINC.

    THINC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    THINC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with THINC.  If not, see <http://www.gnu.org/licenses/>.
*/
/* 
 * Test program for THINC authentication library
 *
 * Authors:
 * Sheikh M. Omer-Farooq - Network Computing Lab - Columbia University
 */

/* set tabstop = 8 */

#include "thinc_auth.h"
#include <stdio.h>
#include <strlen.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
	char *owner;
	struct thinc_user info;
	int err;
	unsigned int len;

	printf( "\n"
		"*********************************************************\n"
		"*** WARNING: This program will print your password on ***\n"
		"*** the screen. Make sure no crazy people are looking ***\n"
		"*** over your shoulder before you continue.           ***\n"
		"*********************************************************"
		"\n\n");

	if(argc >= 2) {
		owner = argv[1];
		len = strlen(owner);
	} else {
		if(thinc_get_owner(getuid(), &owner, &len) == T_AUTH_ERROR) {
                	fprintf(stderr, "usage: %s owner\n", argv[0]);
			exit(1);
		}
		printf("=> using owner %s (%d chars)\n", owner, len);
	}

	if(thinc_get_user_info(&info) == T_AUTH_ERROR) {
		fprintf(stderr, "Couldn't get user info. sorry\n");
		exit(1);
	}

	printf("=> Username. '%s' (%d chars)\n", info.user, info.user_len);
	printf("=> Password. '%s' (%d chars)\n\n", info.passwd, info.pass_len);

	err = thinc_authenticate(&info, owner, len);
	if (err == T_AUTH_NOMATCH) {
		fprintf(stderr, "Yo! the owner and the user don't match. "
			"you trying to do somethin' nasty??\n"
			"NOT Authenticated!\n");
		goto end;
	} else if (err == T_AUTH_ERROR) {
		fprintf(stderr, "Sorry boss, an authentication error "
			"happened. are you sure you're you?\n");
		goto end;
	} else {
		fprintf(stdout, "Success, go party!\n");
	}

end:
	thinc_free_user_info(&info);
	return 0;
}
