#!/usr/bin/perl -w

# I really can't remember what this code does.
#
# Released to the public domain. You may use this
# code any way you wish, private, educational, or commercial.  It's free.

use strict;
use Getopt::Std;

use vars qw($opt_d);
my $debug;

getopts('d');

if($opt_d) { $debug = 1; } else { $debug = 0; }

my $infile = shift or die "no input file\n";

open(INFILE, "$infile") or die "can't open $infile: $!\n";

my (%max, %avg, %avg_max, %count);
my $all = "All";

$max{$all} = 0;
$avg{$all} = 0;
$avg_max{$all} = 0;
$count{$all} = 0;

while(<INFILE>) {
	if(!/max_len/) {
		next;
	}

	chomp;

	s/\(II\) //;
	s/\([0-9][0-9]:[0-9][0-9]:[0-9][0-9]\) //;

	$count{$all}++;
	if(!$debug) { printf("%d\r", $count{$all}); }

	if(/Pixmap/) {
		# take out useless info
		s/max_len//;
		s/len//;
		# XXX: for now we don't care about the pixmap id
		s/\[.*\]//;
		my ($pix, $l, $m) = split;

		if($debug) { printf "%d: $pix $l $m\n", $count{$all}; }

		## pixmap stats
		if($max{$pix}) {
			if($m > $max{$pix}) { $max{$pix} = $m; }
		} else {
			$max{$pix} = $m;
		}

		if($avg{$pix}) {
			$count{$pix}++;
			$avg{$pix} += $l;
			$avg_max{$pix} += $m;
		} else {
			# first one we see 
			$count{$pix} = 1;
			$avg{$pix} = $l;
			$avg_max{$pix} = $m;
		}

		## overall stats 
		if($max{$all} < $m) { $max{$all} = $m; }
		$avg{$all} += $l;
		$avg_max{$all} += $m;
	}
	if(/Client/) {
		s/max_len//;
		s/len//;
		# XXX: for now we don't care about the client id
		# or the scheduler queue
		s/\[.*\]//g;
		my ($cl, $l, $m) = split;

		if($debug) { printf "%d: $cl $l $m\n", $count{$all}; }

		# client stats
		if($max{$cl}) {
			if($m > $max{$cl}) { $max{$cl} = $m; }
		} else {
			$max{$cl} = $m;
		}

		if($avg{$cl}) {
			$count{$cl}++;
			$avg{$cl} += $l;
			$avg_max{$cl} += $m;
		} else {
			# first one we see 
			$count{$cl} = 1;
			$avg{$cl} = $l;
			$avg_max{$cl} = $m;
		}

		## overall stats 
		if($max{$all} < $m) { $max{$all} = $m; }
		$avg{$all} += $l;
		$avg_max{$all} += $m;

	}
}

print("\n");

close(INFILE);

my $i;

print "\nqueue length stats from parsing the log:\n";

foreach $i (sort keys %avg) {
	if($debug) { "processing results for $i\n"; }
	$avg{$i} /= $count{$i};
	$avg_max{$i} /= $count{$i};

	print "\nFor $i got:\n";
	printf "count:            %d\n", $count{$i};
	printf "max length:       %d\n", $max{$i};
	printf "average length:   %.2f\n", $avg{$i};
	printf "average max len:  %.2f\n", $avg_max{$i};
}

print("\nand no more.\n");
