#!/usr/bin/python

# I really can't remember what this code does.
#
# Released to the public domain. You may use this
# code any way you wish, private, educational, or commercial.  It's free.

# set ts = 4

import os, string, sys

verbose = False

def msg(msg):
	if verbose:
		print msg

#def getopts(argv):
#	opts = {}
#	noopts = []
#	while argv:
#		if argv[0][0] == "-":	# find "-name value" pairs
#			try:
#				opts[argv[0]] = argv[1]	# dict key is "-name"
#				argv = argv[2:]
#			except IndexError:
#				msg("error: option needs an argument")
#				raise IndexError
#		else:
#			noopts.append(argv[0])
#			argv = argv[1:]
#	return noopts, opts

def parseOptions():
	from optparse import OptionParser
	opt_parser = OptionParser()
	opt_parser.add_option(
		"-v",
		"--verbose",
		action="store_true",	# flag is turned on
		dest="verbose",
		help="print what's going on"
	)
	opt_parser.add_option(
		"-a",
		"--absolute",
		action="store_true",
		dest="absolute",
		help = "print absolute times (and not relative to the first one " \
			"we see in the log"
	)
	opt_parser.add_option(
		"-R",
		"--raw",
		action="store_true",
		dest="raw",
		help = "just print the raw events"
	)
	opt_parser.add_option(
		"-w",
		"--which",
		action="store",
		dest="which",
		type="int",
		default=-1,
		help="which instrumentation results to parse"
	)
	opt_parser.add_option(
		"-c",
		"--client",
		action="store_true",
		dest="client",
		help="parse the file as being generated by the client (there are " \
			"subtle differences which need to be taken care of)"
	)
	opt_parser.add_option(
		"-C",
		"--cpuspeed",
		action="store",
		dest="cpuspeed",
		type="float",
		help="the speed of the cpu where the measurements where taken. " \
			"If not specified, i will parse /proc/cpuinfo. It should be " \
			"specified look like 449.041 (in MHz)"
	)
	opt_parser.add_option(
		"-A",
		"--aggregates",
		action="store_true",
		dest="agg",
		help="compute some aggregate values from the data"
	)
	opt_parser.add_option(
		"-t",
		"--timeline",
		action="store_true",
		dest="timeline",
		help = "generate a pretty timeline of the data. by default, the " \
			"script will try to analyze the data to compute latency and " \
			"stuff. this option disables that behavior"
	)

	return opt_parser.parse_args()

# filters for file_iter
def rstrip_filter(line):
	return line.rstrip()

def server_filter(line):
	return line.rstrip().replace("(II) ", "")

# it also accepts a filter to apply to each line before returning it.
# the default one does rstrip() so other filters may actually want to
# call it or do the same
def file_iter(file, filter=rstrip_filter):
	"""
	a file iterator. pass a file and it'll return a line at a time. you
	can pass a filter that will operate on the line before it is
	returned
	"""
	for line in open(file):
		yield filter(line)

# which says which dump of the instrumentation records to look for
def instrBegin(line, which = -1):
	if line.find("EVENTS") == -1:
		return False
	if which == -1:
		msg("found one: %s" % line)
		return True
	# ok, looking for a specific dump
	try:
		evs, num = line.split(" ")
		num = int(num)
	except ValueError:
		return False
	if num != which:
		msg("looking for %d, got %d" % (which, num))
		return False
	msg("found _the_ one: %s" % line)
	return True

def instrPredGet(line, ev_dict):
	# It adds an event pair to dict, until it can't parse the passed line
	try:
		num, name = line.split(": ")
	except ValueError:
		return False
	name = name.replace("TI_", "").replace("_", " ")
	msg("=> num " + num + " name " + name)
	ev_dict[int(num)] = name
	return True

def instrNumEvs(line):
	msg("how many events we have? '%s'" % line)
	spl = line.split()
	if(int(spl[2]) != 0):
		print "warning: events wrapped around %d times, the timeline may be "\
			"incomplete" % int(spl[2])
	return int(spl[1])

#def instrEv(line, ev_dict, cpu_speed):
#	"""
#	prints an event parsed from line
#	"""
#	try:
#		name, ev, thigh, tlow = line.split()
#	except ValueError:
#		# not a good line, we're probably finished with the events
#		return False
#
#	cycles = convertTime(long(tlow), long(thigh))
#	time = cyclesToUSec(cycles, cpu_speed)
#	event = ev_dict[int(ev)]
#	if not event:
#		event = ev
#
#	## print it!
#	print "%-32s %-20s %-20ld" % (name, event, time)
#	return True

def instrCheckEnd(line):
	if line.find("TIMELINE END") == -1:
		return False
	else:
		return True

# util functions
def convertTime(tlow, thigh):
	return (thigh << 32) + tlow

# assume speed is in MHz
def cyclesToSec(cycles, speed):
	return cycles/(speed*1000*1000)

def cyclesToUSec(cycles, speed):
	return cycles/speed

def secToCycles(cycles, speed):
	return cycles*speed

def getCpuspeed():
	for line in open("/proc/cpuinfo"):
		if line.find("cpu MHz") == -1:
			continue

		str, mhz = line.split(":")
		break

#	return float(mhz)*1024*1024;
	return float(mhz)

def getTabs(howmany):
	s = ""
	for i in range(0, howmany):
		s += "   "

	return s

def parseLine(line, evs):
	"""
	returns dict with parsed items. dict has following keys:
	name - string
	event - string
	time - float
	"""
	try:
		name, ev, thigh, tlow = line.split()
	except ValueError:
		msg("can't parse your line. raising an exception. either " \
			"someone upstairs catches it or you're doomed")
		## pass on the exception to caller after printing a very useful
		## message
		raise ValueError

	## report just cycles
#	time = convertTime(long(tlow), long(thigh))
	## report microseconds
	cycles = convertTime(long(tlow), long(thigh))
	time = cyclesToUSec(cycles, cpuspeed)
	try:
		event = evs[int(ev)]
	except KeyError:
		event = "UNKNOWN " + ev

	dict = {"name":name, "event":event, "time":time}

#	msg("name %s, event %s, time %10.2f" % \
#		(dict["name"], dict["event"], dict["time"]))
	return dict

def timeline(iter, evs, count):
	if options.agg:
		aggs = {}

	prevtime = 0
	if not options.absolute:
		first = 0
	if options.raw:
		print "%-32s%-20s%-20s%-10s" % \
			("name", "event", "time (us)", "delta (us)")
	else:
		stack = []
		curr_name = ""
		curr_time = 0.0
		tab_count = 0
		
	for line in iter:
		try:
			dict = parseLine(line, evs)
		except ValueError:
			# not a good line, we're probably finished with the events
			msg("not a good line, probably finished '%s'" % line)
			break
		count -= 1

		time = dict["time"]
		name = dict["name"]
		event = dict["event"]

		if not options.absolute:
			if not first:
				first = time
				time = 0
			else:
				time = time - first

		if options.raw:
			# just print it!
			print "%-32s%-20s%-20.2f%-10.2f" % \
				(name, event, time, time-prevtime)
		else:
			total_delta = 0.0
			if event.find("INPUT") != -1:
				is_input = True
			else:
				is_input = False
			# let's try to provide some meaning to this scheisse
			if name == curr_name:
				if event == "END" or is_input:
					msg("end")
					name = "<= " + name
					total_delta = time - curr_time
					if options.agg:
						try:
							aggs[curr_name] += total_delta
						except KeyError:
							aggs[curr_name] = total_delta
					if not is_input:
						tab_count-=1
					space = 60 - (tab_count*3)
					tabs = getTabs(tab_count)
					try:
						(curr_name, curr_time) = stack.pop()
					except IndexError:
						curr_name = ""
						curr_time = 0.0
				else:
					msg("other")
					name = event
					space = 60 - (tab_count*3)
					tabs = getTabs(tab_count)
			else:
				msg("new")
				# a new one
				if curr_name != "":
					stack.append((curr_name, curr_time))
				curr_name = name
				curr_time = time
				name = "=> " + name
				space = 60 - (tab_count*3)
				tabs = getTabs(tab_count)
				# treat input differently
				if not is_input:
					msg("not input")
					tab_count+=1

			# now we can print it
			msg(space)
			if total_delta:
				format = "%s%d%s" % ("%s%-", (space), "s%-20.2f%-10.2f%-10.2f")
				print format % (tabs, name, time, time-prevtime, total_delta)
			else:
				format = "%s%d%s" % ("%s%-", (space), "s%-20.2f%-10.2f")
				print format % (tabs, name, time, time-prevtime)
			msg("====> %s, %f" % (curr_name, curr_time))

		# prepare for next one
		prevtime = time
	else:	# in case we don't do a break above
		print "unexpected EOF. your file sucks!"
		sys.exit(1)

	if count:
		print "didn't process all events. %d missing!" % count
		sys.exit(1)

	if not instrCheckEnd(line):
		print "you suck!"
		sys.exit(1)

	if options.agg:
		print "printing aggs"
		for ev in aggs.keys():
			print "%s: %.2fms (%.2fus)" % (ev, aggs[ev]/1000, aggs[ev])
		print "done"

def isInputLine(line):
	if line.find("INPUT") == -1:
		return False
	else:
		return True

def getLatency(pages):
	"""
	pages is list of dictionaries
	"""
	latency = 0.0
	count = 1
	msg("page  %-20s%-20s%-16s%-8s%-8s" % \
		("start", "end", "time", "time (s)", "ev count"))
	for page in pages:
		start = page["start"]
		end = page["end"]
		page_time = end-start
		latency += page_time
		msg("[%02d]: %-20.2f%-20.2f%-16.2f%-8.2f%-8d" % \
			(count, page["start"], page["end"], page_time, page_time/1000000, \
			page["ev_count"]) \
		)
		count += 1
	
	return latency

# - need 4 INPUTS. then when we get the next INPUT we're finished
def nextPage(iter, line, evs):
	"""
	page is a dict with the following keys:
		start time
		end   time
	line is the current line. we need it because as this method is repeatedly
	called, it ends execution when it finds a line it shouldn't process
	(which is then passed to the next time it's called).
	iter provides line from a file.
	"""
	page = {}
	try:
		dict = parseLine(line, evs)
	except ValueError:
		# can't parse this line. maybe we're at the end?
		return (None, None)
	# first line should be INPUT or something is off
	if not isInputLine(dict["name"]):
		## error
		print "first line in page should be INPUT event"
		raise IndexError ## random exception :)

	page["start"] = dict["time"]
	input_count = 1
	ev_count = 1
	curr_time = 0.0

	# process the rest of the lines until we find the fifth INPUT line
	for line in iter:
		try:
			dict = parseLine(line, evs)
		except ValueError:
			# can't parse this line. maybe we're at the end?
			return (None, None)
		if isInputLine(dict["name"]):
			input_count += 1
			if input_count == 5:
				page["end"] = curr_time
				page["ev_count"] = ev_count
				# we'll have to reparse this line. that's ok 
				return (page, line) 
		else:
			# just a normal page
			ev_count += 1
			curr_time = dict["time"]
	else:
		# let's be safe against crappy input
		print "Unexpected EOF. somebody sucks"
		return (None, None)

def analyze(iter, evs, count):
	pages = []
	page_curr = {}
	page_count = 0

	line = iter.next()
	while True:
		try:
			(page_curr, line) = nextPage(iter, line, evs)
		except IndexError: 
			# random exception raised by nextPage on error :)
			print "YOU SUCK"
			sys.exit(1)
		if not line:
			## we're done
			msg("dat's it. got %d pages" % page_count)
			break
		pages.append(page_curr)
		page_count += 1
		msg("got page #%d. start %.2f, end %.2f, delta %.2f count %d" % \
			(page_count, page_curr["start"], page_curr["end"], \
			page_curr["end"] - page_curr["start"], page_curr["ev_count"]))

	latency = getLatency(pages)
	latency_s = latency/1000000
	print "Pages: %d" % page_count
	print "Latency: %.2fs (%.2fus)" % (latency_s, latency)
	print "Per-Page: %.2fs (%.2fus)" % (latency_s/page_count, \
		latency/page_count)


if __name__ == '__main__':
#	try:
#		args, opts = getopts(sys.argv[1:])
#	except IndexError:
#		print "error: couldn't parse command line"
#		sys.exit()
#
#	try:
#		fn = args[0]
#	except IndexError:
#		print "error: need to pass a filename boy"
#		sys.exit()

	(options, args) = parseOptions()

	try:
		fn = args[0]
	except IndexError:
		print "error: need to pass a filename boy"
		sys.exit(1)

	verbose = options.verbose

	evs = {}
	if options.cpuspeed:
		cpuspeed = options.cpuspeed
	else:
		cpuspeed = getCpuspeed()
	print "your cpu has speed %.3fMHz" % cpuspeed

	msg("filename is '%s', here we go!" % fn)
	msg("looking for the beginning of instrumentation %d..." % options.which)
	if options.client:
		# default filter is fine for the client log
		iter = file_iter(fn)
	else:
		iter = file_iter(fn, server_filter)
	for line in iter:
		if instrBegin(line, options.which):
			msg("...found it")
			break
	else:
		print "couldn't find the beginning. your file sucks!"
		sys.exit(1)

	for line in iter:
		if not instrPredGet(line, evs):
			break

	# here, we're at the EVENTS END line. so read one more to get the	
	# line with TIMELINE <count> <wraps>
	line = iter.next()
	count = instrNumEvs(line)
	print "Have %d events for you, ready?" % count

	if options.timeline:
		timeline(iter, evs, count)
	else:
		analyze(iter, evs, count)

	print "au revoir!"
	sys.exit(0)
