/*
 * I really can't remember what this code does.
 *
 * Released to the public domain. You may use this
 * code any way you wish, private, educational, or commercial.  It's free.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xresource.h>

#define max(x,y)	(((x) > (y)) ? (x) : (y))

#define DEBUG

#ifdef DEBUG
#define print(p)	p
#else
#define print(p)
#endif

static void usage();
static void button_event(XEvent *e, Display *disp, Window win, GC gc);
static void key_event(XEvent *e, Display *disp, Window win, GC gc);
static void change_cursor(Display *disp, Window win, GC gc);

int main(int argc, char **argv)
{
	int done = 0;
	XEvent event;	/* current event */
	char *window_title = "Test Input";
	char *app_name = "Test Input";
	unsigned long fgpix, bgpix;

	/* x stuff */
	Display                 *disp;  /* connection to X display */
	Window                  win;	/* the window */
	GC                      gc;     /* gc for window */
	XGCValues 		gcv;
	XWMHints                *xwmh;        /* hints for wm */
	XSizeHints              *xsh;         /* size hints for wm */
	XClassHint              *ch;          /* class hint for wm */
	XSetWindowAttributes 	xswa;
	XTextProperty   	wname;          /* window name */
	XTextProperty   	iname;          /* icon name */

	if(argc == 2 && !strcmp(argv[1], "-h")) {
		usage(argv[0]);
		return 0;
	}

	/* open display connection */
	if((disp = XOpenDisplay(NULL)) == NULL) {
		fprintf(stderr, "%s: can't open display %s\n", argv[0], 
			XDisplayName(NULL));
		exit(1);
	}

	bgpix = WhitePixel(disp, DefaultScreen(disp));
	fgpix = BlackPixel(disp, DefaultScreen(disp));

	/* select initial pos and size of top window */
	/* the XSizeHints is used to inform the WM. size here is just enough to
	 * fit text */
	if((xsh = XAllocSizeHints()) == NULL) {
		fprintf(stderr, "%s: Error allocating size hints\n", app_name);
		exit(1);
	}

	/* we're setting the preferred possition, size and min size of window */
	xsh->flags = (PPosition | PSize | PMinSize);
	xsh->x = 0;
	xsh->y = 0;
	xsh->min_height = xsh->height = 100;
	xsh->min_width = xsh->width = 100;

	/* Create top level window */
	win = XCreateSimpleWindow(disp, DefaultRootWindow(disp), 0,
		0, xsh->width, xsh->height, 0, fgpix, bgpix);

	/* Set wm properties */
	if((ch = XAllocClassHint()) == NULL) {
		fprintf(stderr, "%s: Error allocating class hint\n", app_name);
		exit(1);
	}
	ch->res_name = app_name;
	ch->res_class = app_name;

	/* XTextProperty for window and icon name */
	if(XStringListToTextProperty(&window_title, 1, &wname) == 0) {
		fprintf(stderr, "%s: Error creating XTextProperty\n", app_name);
		exit(1);
	}
	if(XStringListToTextProperty(&window_title, 1, &iname) == 0) {
		fprintf(stderr, "%s: Error creating XTextProperty\n", app_name);
		exit(1);
	}

	if((xwmh = XAllocWMHints()) == NULL) {
		fprintf(stderr, "%s: Error allocating WM hints\n", app_name);
		exit(1);
	}
	xwmh->flags = (InputHint|StateHint);
	xwmh->input = True;
	xwmh->initial_state = NormalState;
	XSetWMProperties(disp, win, &wname, &iname, argv, argc, xsh, xwmh,
		ch);

	/* create graphics context for main window */
	gcv.foreground = fgpix;
	gcv.background = bgpix;
	gc = XCreateGC(disp, win, (GCForeground | GCBackground), &gcv);

	/* set window attributes */
	xswa.colormap = DefaultColormap(disp, DefaultScreen(disp));
	xswa.bit_gravity = CenterGravity;
	xswa.event_mask = ExposureMask | PointerMotionMask 
		| ButtonPressMask | ButtonReleaseMask
		| KeyPressMask | KeyReleaseMask;
	XChangeWindowAttributes(disp, win, 
		(CWColormap | CWBitGravity | CWEventMask), &xswa);

	/* Map window to make it visible. Note:
	 * XMapWindow() doesn't actually map the window; it sends a message to
	 * the window manager asking it to map the window. You must wait for an
	 * Exposure event from the server before drawing. This event indicates 
	 * that your window is on the screen and ready to receive graphics. 
	 * In general, you should always draw in response to Exposure events.*/
	XMapWindow(disp, win);

	change_cursor(disp, win, gc);

	XFlush(disp);

	/* Event loop */
	printf("all set, entering event loop...\n");
	while(!done) {
		XNextEvent(disp, &event);
		switch(event.type) {
			case Expose: 
				if(event.xexpose.count == 0)
					XClearWindow(disp, win);
				break;
			case ButtonPress: 
				button_event(&event, disp, win, gc);
				break;
			case ButtonRelease:
				button_event(&event, disp, win, gc);
				break;
			case MotionNotify:
				break;
			case KeyPress:
				key_event(&event, disp, win, gc);
				break;
			case KeyRelease:
				key_event(&event, disp, win, gc);
				break;
			default:
				printf("i don't know this input event: %d\n",
					event.type);
				done = 1;
		}
	}

	fprintf(stderr, "you bastard!\n");

	/* the end */
	XFreeGC(disp, gc);
	XDestroyWindow(disp, win);
	XCloseDisplay(disp);
	exit(0);
}

static void usage(const char *app_name)
{
#if 0
	fprintf(stderr, "usage: %s [-display host:display] "
		"[-geometry geom] [-msgtext text] [-extext text]\n", app_name);
#else
	fprintf(stderr, "usage: %s\n", app_name);
#endif
}

static void button_event(XEvent *e, Display *disp, Window win, GC gc)
{
	static int count = 0;
	printf("button event at (%d,%d)\n", e->xbutton.x, e->xbutton.y);
#if 0
	XDrawPoint(disp, win, gc, e->xbutton.x, e->xbutton.y);
#else
	XFillRectangle(disp, win, gc, e->xbutton.x-1, e->xbutton.y-1, 3, 3);
#endif

	++count;
	if(count == 10) {
		change_cursor(disp, win, gc);
		count = 0;
	}
}

static void key_event(XEvent *e, Display *disp, Window win, GC gc)
{
	char keyname[256], *ksname;
	KeySym ks;
	printf("keyboard event %d\n", e->xkey.keycode);

#if 0
	printf("event converted to %d\n", 
		XKeycodeToKeysym(disp, e->xkey.keycode, 0));
#endif
	XLookupString(&e->xkey, keyname, 255, &ks, NULL);

	if(ks == NoSymbol) {
		printf("no symbol!\n");
		return;
	}

	ksname = XKeysymToString(ks);
	if(!ksname) {
		printf("no keysym name!\n");
		return;
	}

	printf("converted to %s %#lx\n", ksname, ks);
}

static const char source[] = {
	0x00,0x01,
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0xFF,0xFF, 
	0x00,0x01,
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01 
};

static const char mask[] = {
	0x00,0x01,
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0xFF,0xFF, 
	0x00,0x01,
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01, 
	0x00,0x01 
};

static void change_cursor(Display *disp, Window win, GC gc)
{
	static int x=8, y=1;
	Pixmap s, m;
	XColor fg, bg;
	Cursor cursor;

	s = XCreateBitmapFromData(disp, win, source, 16, 16);
	m = XCreateBitmapFromData(disp, win, mask, 16, 16);

	fg.pixel = 0;
	fg.red = 0;
	fg.green = 0;
	fg.blue = 0;
	bg.pixel = 0;
	bg.red = 0;
	bg.green = 0;
	bg.blue = 0;
	printf("xhot %d, yhot %d\n", x, y);

	cursor = XCreatePixmapCursor(disp, s, m, &fg, &bg, x,y);

	XDefineCursor(disp, win, cursor);

	XFreePixmap(disp, s);
	XFreePixmap(disp, m);

/*	x = (x+5)%16; */
	y = (y+6)%16;
}
