/**************************************************************************
 *
 * Copyright 2004-2005 Columbia University
 * All Rights Reserved
 *
 **************************************************************************/
/*
 * Application sharing utility
 *
 * Authors: 
 * Ricardo A. Baratto - Network Computing Lab - Columbia University
 */

/* XXX XXX
 * Warning: this code is unfinished.
 */

/* 
 * you need the window navigator constructor kit (wnck) to run this. 
 * apt-get install libwnck-dev
 */

/* Notes for the future:
 * - Class group is highest level of abstraction. Then apps, then windows.
 */

/* set tabstop = 4 */

#include <stdio.h>
#include <stdlib.h>

#define WNCK_I_KNOW_THIS_IS_UNSTABLE
#include <libwnck/libwnck.h>
#include <libwnck/class-group.h>	/* not included by default */
#include <gtk/gtk.h>

static void print_all_windows(WnckScreen *screen);
static GList* add_app(GList *apps, WnckApplication *app);
static void show_fancy_window();

int main(int argc, char **argv)
{
	WnckScreen *screen;

	gtk_init (&argc, &argv);

	screen = wnck_screen_get_default ();
	if(!screen) {
		printf("wtf?\n");
		return EXIT_FAILURE;
	}

#if 1
	show_fancy_window(screen);
#else
#if 0
	/* because the pager doesn't respond to signals at the moment */
	wnck_screen_force_update (screen);
#endif
	print_all_windows(screen);
	printf("bye.\n");
#endif

	return EXIT_SUCCESS;
}

static void print_all_windows(WnckScreen *screen)
{
	GList *c, *wa, *apps = NULL;
	WnckWindow *window, *active;
	WnckApplication *app;
	int i;

	active = wnck_screen_get_active_window(screen);
	if(!active) {
		printf("no active window!\n");
		return;
	}

	c = wnck_screen_get_windows_stacked(screen);
	printf("have %d windows\n", g_list_length(c));

	for (; c; c = c->next) {
		window = c->data;
#if 0
		if (wnck_window_is_skip_tasklist(window))
			/* ignore if skip_tasklist */ 
			continue;
#endif
		/* let's go one level up */
		app = wnck_window_get_application(window);

		apps = add_app(apps, app);
		if(!apps) {
			printf("can't add app to list\n");
			return;
		}
	}
	printf("have %d apps\n", g_list_length(apps));
	for(c=apps; c; c = c->next) {
		WnckClassGroup *g;
		app = c->data;
		printf("application '%s' (%s):\n", wnck_application_get_name(app),
			wnck_application_get_startup_id(app));
		
		wa = wnck_application_get_windows(app);
		printf("\t=> has %d windows\n", g_list_length(wa));
		for(i=0; wa; wa=wa->next, ++i) {
			window = wa->data;
			printf(
				"\t=> [%d] id: %#lx\n"
				"\t=> [%d] name: '%s'\n"
				"\t=> [%d] pid: %d\n"
				,i,wnck_window_get_xid(window)
				,i,wnck_window_get_name(window)
				,i,wnck_window_get_pid(window)
			);
			if(window == active) {
				printf("\t=> [%d] ACTIVE WINDOW\n", i);
			}
			if(wnck_window_is_sticky(window)) {
				printf("\t=> [%d] STICKY\n", i);
			} else {
				printf("\t=> [%d] workspace %d: '%s'\n", i,
					wnck_workspace_get_number(wnck_window_get_workspace(window)),
					wnck_workspace_get_name(wnck_window_get_workspace(window))
				);
			}
			g = wnck_window_get_class_group(window);
			printf(
					"\t=> [%d] class group:\n"
					"\t\t=> res_class '%s'\n"
					"\t\t=> name '%s'\n"
					, i
					, wnck_class_group_get_name(g)
					, wnck_class_group_get_res_class(g)
			);
		}
	}
}

/* if app is not in apps, it adds it to the list. the new list is returned */
static GList* add_app(GList *apps, WnckApplication *app)
{
	if(g_list_find(apps, app))
		return apps;
	else
		return g_list_prepend(apps, app);
}

static void show_fancy_window(WnckScreen *screen)
{
	GtkWidget *win, *tasklist, *frame;
	win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size (GTK_WINDOW (win), 200, 100);
	gtk_window_stick (GTK_WINDOW (win));
	/*   wnck_gtk_window_set_dock_type (GTK_WINDOW (win)); */

	gtk_window_set_title (GTK_WINDOW (win), "Task List");
	gtk_window_set_policy (GTK_WINDOW (win),
			TRUE, TRUE, FALSE);

	/* quit on window close */
	g_signal_connect (G_OBJECT (win), "destroy",
			G_CALLBACK (gtk_main_quit),
			NULL);

	tasklist = wnck_tasklist_new (screen);

	wnck_tasklist_set_grouping (WNCK_TASKLIST (tasklist), WNCK_TASKLIST_ALWAYS_GROUP);
	frame = gtk_frame_new (NULL);
	gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);
	gtk_container_add (GTK_CONTAINER (win), frame);

	gtk_container_add (GTK_CONTAINER (frame), tasklist);

	gtk_widget_show (tasklist);
	gtk_widget_show (frame);

	gtk_window_move (GTK_WINDOW (win), 0, 0);

	gtk_widget_show (win);

	gtk_main ();
}
